#ifndef _STUDENTINCOURSECOLLECTION_H
#define _STUDENTINCOURSECOLLECTION_H

#include <string>
#include <fstream>

#include "Student.h"
#include "Course.h"
#include "StudentInCourseCollection.h"

using namespace std;

class CourseCollection;
class StudentCollection;

class StudentInCourseCollection
{ // version 1
public:
   StudentInCourseCollection();
   ~StudentInCourseCollection()  {  delete[] siccArr;  };
// getters
   size_t getNOfStudentInCourses() const
   {  return siccNOfStudentInCourses;  }
   const StudentInCourse* getArr() const {  return siccArr;  }
   const StudentCollection* getPAllStudents() const
   {  return siccPAllStudents;  }
   const CourseCollection* getPAllCourses( ) const
   {  return siccPAllCourses;  }
// setters
   void setPAllStudents( StudentCollection* pStudents )
   {  siccPAllStudents = pStudents;  }
   void setPAllCourses( CourseCollection* pCourses )
   {  siccPAllCourses = pCourses;  }
// 1 StudentInCourse
   bool find1StudentInCourse( int aIdNum, string code ) const
   {  return ( findNdx(aIdNum, code) >= 0 );  }
   void delete1StudentInCourse( int aIdNum, string code );
   void add1StudentInCourse( const StudentInCourse& aStdnInCrs );
   const StudentInCourse& get1StudentInCourse( int aIdNum,
                                               string code ) const; 
// other
   void save( ofstream& bout ) const;
   void load( ifstream& bin );
   void swapArr( StudentInCourseCollection& rhs );
   void display( ostream& tout ) const; 
private:
   enum { siccIncr = 50 };
   StudentInCourse*   siccArr;
   size_t             siccNOfStudentInCourses;
   size_t             siccReserved;
   StudentCollection* siccPAllStudents;
   CourseCollection*  siccPAllCourses;

   StudentInCourseCollection(
                       const StudentInCourseCollection& rhs ) { };
   StudentInCourseCollection& operator=(
                       const StudentInCourseCollection& rhs ) { };

   void erase1StudentInCourse( int ndx );
   void insert1StudentInCourse( const StudentInCourse& aStdnInCrs );
   int findNdx( int aIdNum, string code ) const;
}; // StudentInCourseCollection

struct StudentInCourseCollectionXptn // version 1
{
   enum { allocFailed, notFound, noCrs, unknownCrs, noStdnt,
          unknownStdn, fileNotOpen, cannotWrite, cannotRead };
   char methodName[100];
   int  errorCode;
   char errStrVal[100];
   char errIntVal;
   StudentInCourse::SICKey errSICVal;
   StudentInCourseCollectionXptn( const char* mn, int ec, const char* sv="" )
      :  errorCode( ec )
   {  strncpy( methodName, mn, 99 );  methodName[99] = '\0';
      strncpy( errStrVal, sv, 99 );  errStrVal[99] = '\0';  };
   StudentInCourseCollectionXptn( const char* mn, int ec, int iv )
      :  errorCode( ec ),  errIntVal( iv )
   {  strncpy( methodName, mn, 99 );  methodName[99] = '\0';  };
   StudentInCourseCollectionXptn( const char* mn, int ec,
                                  const StudentInCourse::SICKey& sk )
      :  errorCode( ec ),  errSICVal( sk )
   {  strncpy( methodName, mn, 99 );  methodName[99] = '\0';  };
}; // StudentInCourseCollectionXptn

#endif // _STUDENTINCOURSECOLLECTION_H
